]>
git.ipfire.org Git - thirdparty/git.git/blob - git-cvsexportcommit.perl
4 # - does not propagate permissions
5 # - error handling has not been extensively tested
10 use File
:: Temp
qw(tempdir) ;
12 use File
:: Basename
qw(basename dirname) ;
14 unless ( $ENV { GIT_DIR
} && - r
$ENV { GIT_DIR
}){
15 die "GIT_DIR is not defined or is unreadable" ;
18 our ( $opt_h , $opt_P , $opt_p , $opt_v , $opt_c , $opt_f , $opt_a , $opt_m , $opt_d );
20 getopts
( 'hPpvcfam:d:' );
24 die "Need at least one commit identifier!" unless @ARGV ;
28 @cvs = ( 'cvs' , '-d' , $opt_d );
34 our ( $tmpdir , $tmpdirname ) = tempdir
( 'git-cvsapplycommit-XXXXXX' ,
38 # resolve target commit
41 $commit = safe_pipe_capture
( 'git-rev-parse' , '--verify' , " $commit ^0" );
44 die "The commit reference $commit did not resolve!" ;
47 # resolve what parent we want
51 $parent = safe_pipe_capture
( 'git-rev-parse' , '--verify' , " $parent ^0" );
54 die "The parent reference did not resolve!" ;
58 # find parents from the commit itself
59 my @commit = safe_pipe_capture
( 'git-cat-file' , 'commit' , $commit );
63 my $stage = 'headers' ; # headers, msg
67 foreach my $line ( @commit ) {
69 if ( $stage eq 'headers' && $line eq '' ) {
74 if ( $stage eq 'headers' ) {
75 if ( $line =~ m/^parent (\w{40})$/ ) { # found a parent
77 } elsif ( $line =~ m/^author (.+) \d+ [-+]\d+$/ ) {
79 } elsif ( $line =~ m/^committer (.+) \d+ [-+]\d+$/ ) {
92 # double check that it's a valid parent
93 foreach my $p ( @parents ) {
99 die "Did not find $parent in the parents for this commit!" if ! $found and ! $opt_P ;
100 } else { # we don't have a parent from the cmdline...
101 if ( @parents == 1 ) { # it's safe to get it from the commit
102 $parent = $parents [ 0 ];
103 } else { # or perhaps not!
104 die "This commit has more than one parent -- please name the parent you want to use explicitly" ;
108 $opt_v && print "Applying to CVS commit $commit from parent $parent \n " ;
110 # grab the commit message
111 open ( MSG
, ">.msg" ) or die "Cannot open .msg for writing" ;
117 print MSG
" \n\n Author: $author \n " ;
118 if ( $author ne $committer ) {
119 print MSG
"Committer: $committer \n " ;
124 `git-diff-tree --binary -p $parent $commit >.cvsexportcommit.diff` ; # || die "Cannot diff";
126 ## apply non-binary changes
127 my $fuzz = $opt_p ?
0 : 2 ;
129 print "Checking if patch will apply \n " ;
132 open APPLY
, "GIT_DIR= git-apply -C $fuzz --binary --summary --numstat<.cvsexportcommit.diff|" || die "cannot patch" ;
134 close APPLY
|| die "Cannot patch" ;
135 my ( @bfiles , @files , @afiles , @dfiles );
138 push ( @bfiles , $1 ) if m/^-\t-\t(.*)$/ ;
139 push ( @files , $1 ) if m/^-\t-\t(.*)$/ ;
140 push ( @files , $1 ) if m/^\d+\t\d+\t(.*)$/ ;
141 push ( @afiles , $1 ) if m/^ create mode [0-7]+ (.*)$/ ;
142 push ( @dfiles , $1 ) if m/^ delete mode [0-7]+ (.*)$/ ;
144 map { s/^"(.*)"$/$1/g } @bfiles , @files ;
145 map { s/\\([0-7]{3})/sprintf('%c',oct $1)/eg } @bfiles , @files ;
147 # check that the files are clean and up to date according to cvs
150 foreach my $p ( @afiles ) {
151 my $path = dirname
$p ;
152 while (!- d
$path and ! grep { $_ eq $path } @dirs ) {
153 unshift @dirs , $path ;
154 $path = dirname
$path ;
158 foreach my $d ( @dirs ) {
161 warn " $d exists and is not a directory! \n " ;
164 foreach my $f ( @afiles ) {
165 # This should return only one value
166 if ( $f =~ m
,(.*) /[^/ ]*$,) {
168 next if ( grep { $_ eq $p } @dirs );
170 my @status = grep ( m/^File/ , safe_pipe_capture
( @cvs , '-q' , 'status' , $f ));
171 if ( @status > 1 ) { warn 'Strange! cvs status returned more than one line?' };
172 if (- d dirname
$f and $status [ 0 ] !~ m/Status: Unknown$/
173 and $status [ 0 ] !~ m/^File: no file / ) {
175 warn "File $f is already known in your CVS checkout -- perhaps it has been added by another user. Or this may indicate that it exists on a different branch. If this is the case, use -f to force the merge. \n " ;
176 warn "Status was: $status [0] \n " ;
180 foreach my $f ( @files ) {
181 next if grep { $_ eq $f } @afiles ;
182 # TODO:we need to handle removed in cvs
183 my @status = grep ( m/^File/ , safe_pipe_capture
( @cvs , '-q' , 'status' , $f ));
184 if ( @status > 1 ) { warn 'Strange! cvs status returned more than one line?' };
185 unless ( $status [ 0 ] =~ m/Status: Up-to-date$/ ) {
187 warn "File $f not up to date in your CVS checkout! \n " ;
191 if ( $opt_f ) { warn "The tree is not clean -- forced merge \n " ;
194 die "Exiting: your CVS tree is not clean for this merge." ;
199 `GIT_DIR= git-apply -C $fuzz --binary --summary --numstat --apply <.cvsexportcommit.diff` || die "cannot patch" ;
201 print "Patch applied successfully. Adding new files and directories to CVS \n " ;
203 foreach my $d ( @dirs ) {
204 if ( system ( @cvs , 'add' , $d )) {
206 warn "Failed to cvs add directory $d -- you may need to do it manually" ;
210 foreach my $f ( @afiles ) {
211 if ( grep { $_ eq $f } @bfiles ) {
212 system ( @cvs , 'add' , '-kb' , $f );
214 system ( @cvs , 'add' , $f );
218 warn "Failed to cvs add $f -- you may need to do it manually" ;
222 foreach my $f ( @dfiles ) {
223 system ( @cvs , 'rm' , '-f' , $f );
226 warn "Failed to cvs rm -f $f -- you may need to do it manually" ;
230 print "Commit to CVS \n " ;
231 print "Patch title (first comment line): $title \n " ;
232 my @commitfiles = map { unless ( m/\s/ ) { ' \' ' . $_ . ' \' ' ; } else { $_ ; }; } ( @files );
233 my $cmd = join ( ' ' , @cvs ). " commit -F .msg @commitfiles " ;
236 print "NOTE: One or more hunks failed to apply cleanly. \n " ;
237 print "You'll need to apply the patch in .cvsexportcommit.diff manually \n " ;
238 print "using a patch program. After applying the patch and resolving the \n " ;
239 print "problems you may commit using:" ;
245 print "Autocommit \n $cmd \n " ;
246 print safe_pipe_capture
( @cvs , 'commit' , '-F' , '.msg' , @files );
248 die "Exiting: The commit did not succeed" ;
250 print "Committed successfully to CVS \n " ;
254 print "Ready for you to commit, just run: \n\n $cmd \n " ;
258 unlink ( ".cvsexportcommit.diff" );
262 Usage: GIT_DIR=/path/to/.git ${ \b asename $0 } [-h] [-p] [-v] [-c] [-f] [-m msgprefix] [ parent ] commit
267 # An alternative to `command` that allows input to be passed as an array
268 # to work around shell problems with weird characters in arguments
269 # if the exec returns non-zero we die
270 sub safe_pipe_capture
{
272 if ( my $pid = open my $child , '-|' ) {
273 @output = (< $child >);
274 close $child or die join ( ' ' , @_ ). ": $! $?" ;
276 exec ( @_ ) or die "$! $?" ; # exec() can fail the executable can't be found
278 return wantarray ?
@output : join ( '' , @output );
281 sub safe_pipe_capture_blob
{
283 if ( my $pid = open my $child , '-|' ) {
286 $output = (< $child >);
287 close $child or die join ( ' ' , @_ ). ": $! $?" ;
289 exec ( @_ ) or die "$! $?" ; # exec() can fail the executable can't be found